require_relative 'treasure_trove'
require_relative 'playable'

module StudioGame
	class Player
		include Playable

		def initialize(name,health=100)
			@name = name.capitalize
			@health = health
			@found_treasures = Hash.new(0)
		end

		attr_accessor:health
		attr_accessor :name

		def to_s
			"I'm #{@name} with health = #{@health}, points = #{points}, and score = #{score}."
			#{ }"I'm #{@name} with a health of #{@health} and a score of #{score}"
		end



		def score
			@health + points
		end

		def points
			@found_treasures.values.reduce(0,:+)
		end



		def <=>(other_player)
			other_player.score <=> score
		end

		def found_treasure(treasure)
			@found_treasures[treasure.name] += treasure.points
			puts "#{@name} found a #{treasure.name} worth #{treasure.points} points"
			puts "#{@name}'s treasures: #{@found_treasures}"
		end

		def each_found_treasure
			@found_treasures.each do |name,points|
				yield Treasure.new(name,points)
			end
		end

		def self.from_csv(csv_string)
			name,health = csv_string.split(",")
			Player.new(name,Integer(health))
		end
	end
end


if __FILE__ == $0
	player = Player.new("moe")
	puts player.name
	puts player.health
	player.w00t
	puts player.health
	player.blam
	puts player.health
end